scala.collection.parallel.immutable

# ParRange

#### class ParRange extends ParSeq[Int] with Serializable

Parallel ranges.

This is a base trait for Scala parallel collections. It defines behaviour common to all parallel collections. Concrete parallel collections should inherit this trait and `ParIterable` if they want to define specific combiner factories.

Parallel operations are implemented with divide and conquer style algorithms that parallelize well. The basic idea is to split the collection into smaller parts until they are small enough to be operated on sequentially.

All of the parallel operations are implemented as tasks within this trait. Tasks rely on the concept of splitters, which extend iterators. Every parallel collection defines:

    def splitter: IterableSplitter[T]

which returns an instance of `IterableSplitter[T]`, which is a subtype of `Splitter[T]`. Splitters have a method `remaining` to check the remaining number of elements, and method `split` which is defined by splitters. Method `split` divides the splitters iterate over into disjunct subsets:

    def split: Seq[Splitter]

which splits the splitter into a sequence of disjunct subsplitters. This is typically a very fast operation which simply creates wrappers around the receiver collection. This can be repeated recursively.

Tasks are scheduled for execution through a scala.collection.parallel.TaskSupport object, which can be changed through the `tasksupport` setter of the collection.

Method `newCombiner` produces a new combiner. Combiners are an extension of builders. They provide a method `combine` which combines two combiners and returns a combiner containing elements of both combiners. This method can be implemented by aggressively copying all the elements into the new combiner or by lazily binding their results. It is recommended to avoid copying all of the elements for performance reasons, although that cost might be negligible depending on the use case. Standard parallel collection combiners avoid copying when merging results, relying either on a two-step lazy construction or specific data-structure properties.

Methods:

    def seq: Sequential
    def par: Repr

produce the sequential or parallel implementation of the collection, respectively. Method `par` just returns a reference to this parallel collection. Method `seq` is efficient - it will not copy the elements. Instead, it will create a sequential version of the collection using the same underlying data structure. Note that this is not the case for sequential collections in general - they may copy the elements and produce a different underlying data structure.

The combination of methods `toMap`, `toSeq` or `toSet` along with `par` and `seq` is a flexible way to change between different collection types.

Since this trait extends the `GenIterable` trait, methods like `size` must also be implemented in concrete collections, while `iterator` forwards to `splitter` by default.

Each parallel collection is bound to a specific fork/join pool, on which dormant worker threads are kept. The fork/join pool contains other information such as the parallelism level, that is, the number of processors used. When a collection is created, it is assigned the default fork/join pool found in the `scala.parallel` package object.

Parallel collections are not necessarily ordered in terms of the `foreach` operation (see `Traversable`). Parallel sequences have a well defined order for iterators - creating an iterator and traversing the elements linearly will always yield the same order. However, bulk operations such as `foreach`, `map` or `filter` always occur in undefined orders for all parallel collections.

Existing parallel collection implementations provide strict parallel iterators. Strict parallel iterators are aware of the number of elements they have yet to traverse. It's also possible to provide non-strict parallel iterators, which do not know the number of elements remaining. To do this, the new collection implementation must override `isStrictSplitterCollection` to `false`. This will make some operations unavailable.

To create a new parallel collection, extend the `ParIterable` trait, and implement `size`, `splitter`, `newCombiner` and `seq`. Having an implicit combiner factory requires extending this trait in addition, as well as providing a companion object, as with regular collections.

Method `size` is implemented as a constant time operation for parallel collections, and parallel collection operations rely on this assumption.

The higher-order functions passed to certain operations may contain side-effects. Since implementations of bulk operations may not be sequential, this means that side-effects may not be predictable and may produce data-races, deadlocks or invalidation of state if care is not taken. It is up to the programmer to either avoid using side-effects or to use some form of synchronization when accessing mutable data.

Self Type
  ParRange
Annotations
  @SerialVersionUID ( uid = 1L )
Source
  ParRange.scala
Since

  2.9

See also

  Scala's Parallel Collections Library overview section on `ParRange` for more information.

Linear Supertypes
Serializable, java.io.Serializable, ParSeq[Int], ParIterable[Int], Immutable, parallel.ParSeq[Int], ParSeqLike[Int, ParSeq[Int], immutable.Seq[Int]], parallel.ParIterable[Int], ParIterableLike[Int, ParSeq[Int], immutable.Seq[Int]], Parallel, CustomParallelizable[Int, ParSeq[Int]], GenericParTemplate[Int, ParSeq], HasNewCombiner[Int, scala.collection.parallel.immutable.ParSeq[Int] @scala.annotation.unchecked.uncheckedVariance], GenSeq[Int], GenIterable[Int], GenTraversable[Int], GenericTraversableTemplate[Int, ParSeq], HasNewBuilder[Int, scala.collection.parallel.immutable.ParSeq[Int] @scala.annotation.unchecked.uncheckedVariance], GenSeqLike[Int, ParSeq[Int]], Equals, GenIterableLike[Int, ParSeq[Int]], GenTraversableLike[Int, ParSeq[Int]], Parallelizable[Int, ParSeq[Int]], GenTraversableOnce[Int], AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ParRange
2. Serializable
3. Serializable
4. ParSeq
5. ParIterable
6. Immutable
7. ParSeq
8. ParSeqLike
9. ParIterable
10. ParIterableLike
11. Parallel
12. CustomParallelizable
13. GenericParTemplate
14. HasNewCombiner
15. GenSeq
16. GenIterable
17. GenTraversable
18. GenericTraversableTemplate
19. HasNewBuilder
20. GenSeqLike
21. Equals
22. GenIterableLike
23. GenTraversableLike
24. Parallelizable
25. GenTraversableOnce
26. AnyRef
27. Any

Implicitly

1. by traversable2ops
2. by any2stringadd
3. by any2stringfmt
4. by any2ArrowAssoc
5. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new ParRange(range: immutable.Range)

   range

     the sequential range this parallel range was obtained from

### Type Members

1. #### trait Accessor [R, Tp] extends ParSeqLike.Accessor[R, Tp]

   Standard accessor task that iterates over the elements of the collection.

2. #### class Aggregate [S] extends Accessor[S, Aggregate[S]]

   Attributes
     protected[this]
   Definition Classes
     ParIterableLike

3. #### trait BuilderOps [Elem, To] extends AnyRef

   Definition Classes
     ParIterableLike

4. #### class Collect [S, That] extends Transformer[Combiner[S, That], Collect[S, That]]

   Attributes
     protected[this]
   Definition Classes
     ParIterableLike

5. #### abstract class Composite [FR, SR, R, First <: StrictSplitterCheckTask[FR, _], Second <: StrictSplitterCheckTask[SR, _]] extends NonDivisibleTask[R, Composite[FR, SR, R, First, Second]]

   Attributes
     protected[this]
   Definition Classes
     ParIterableLike

6. #### class Copy [U >: T, That] extends Transformer[Combiner[U, That], Copy[U, That]]

   Attributes
     protected
   Definition Classes
     ParIterableLike

7. #### class CopyToArray [U >: T, This >: Repr] extends Accessor[Unit, CopyToArray[U, This]]

   Attributes
     protected[this]
   Definition Classes
     ParIterableLike

8. #### class Corresponds [S] extends Accessor[Boolean, Corresponds[S]]

   Attributes
     protected[this]
   Definition Classes
     ParSeqLike

9. #### class Count extends Accessor[Int, Count]

   Attributes
     protected[this]
   Definition Classes
     ParIterableLike

10. #### class CreateScanTree [U >: T] extends Transformer[ScanTree[U], CreateScanTree[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

11. #### class Drop [U >: T, This >: Repr] extends Transformer[Combiner[U, This], Drop[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

12. #### abstract class Elements extends SeqSplitter[T] with scala.BufferedIterator[T]

    Used to iterate elements using indices

13. #### class Exists extends Accessor[Boolean, Exists]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

14. #### class Filter [U >: T, This >: Repr] extends Transformer[Combiner[U, This], Filter[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

15. #### class FilterNot [U >: T, This >: Repr] extends Transformer[Combiner[U, This], FilterNot[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

16. #### class Find [U >: T] extends Accessor[Option[U], Find[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

17. #### class FlatMap [S, That] extends Transformer[Combiner[S, That], FlatMap[S, That]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

18. #### class Fold [U >: T] extends Accessor[U, Fold[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

19. #### class Forall extends Accessor[Boolean, Forall]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

20. #### class Foreach [S] extends Accessor[Unit, Foreach[S]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

21. #### class FromScanTree [U >: T, That] extends StrictSplitterCheckTask[Combiner[U, That], FromScanTree[U, That]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

22. #### class GroupBy [K, U >: T] extends Transformer[HashMapCombiner[K, U], GroupBy[K, U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

23. #### class IndexWhere extends Accessor[Int, IndexWhere]

    Attributes
      protected[this]
    Definition Classes
      ParSeqLike

24. #### class LastIndexWhere extends Accessor[Int, LastIndexWhere]

    Attributes
      protected[this]
    Definition Classes
      ParSeqLike

25. #### class Map [S, That] extends Transformer[Combiner[S, That], Map[S, That]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

26. #### class Max [U >: T] extends Accessor[Option[U], Max[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

27. #### class Min [U >: T] extends Accessor[Option[U], Min[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

28. #### trait NonDivisible [R] extends NonDivisibleTask[R, NonDivisible[R]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

29. #### trait NonDivisibleTask [R, Tp] extends StrictSplitterCheckTask[R, Tp]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

30. #### abstract class ParComposite [FR, SR, R, First <: StrictSplitterCheckTask[FR, _], Second <: StrictSplitterCheckTask[SR, _]] extends Composite[FR, SR, R, First, Second]

    Performs two tasks in parallel, and waits for both to finish.

31. #### class ParRangeIterator extends SeqSplitter[Int]

32. #### class Partition [U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), Partition[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

33. #### class Product [U >: T] extends Accessor[U, Product[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

34. #### class Reduce [U >: T] extends Accessor[Option[U], Reduce[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

35. #### abstract class ResultMapping [R, Tp, R1] extends NonDivisibleTask[R1, ResultMapping[R, Tp, R1]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

36. #### class Reverse [U >: T, This >: Repr] extends Transformer[Combiner[U, This], Reverse[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParSeqLike

37. #### class ReverseMap [S, That] extends Transformer[Combiner[S, That], ReverseMap[S, That]]

    Attributes
      protected[this]
    Definition Classes
      ParSeqLike

38. #### type SSCTask[R, Tp] = StrictSplitterCheckTask[R, Tp]

    Definition Classes
      ParIterableLike

39. #### class SameElements [U >: T] extends Accessor[Boolean, SameElements[U]]

    Attributes
      protected[this]
    Definition Classes
      ParSeqLike

40. #### case class ScanLeaf [U >: T](pit: IterableSplitter[U], op: (U, U) ⇒ U, from: Int, len: Int, prev: Option[ScanLeaf[U]], acc: U) extends ScanTree[U] with scala.Product with Serializable

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

41. #### case class ScanNode [U >: T](left: ScanTree[U], right: ScanTree[U]) extends ScanTree[U] with scala.Product with Serializable

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

42. #### trait ScanTree [U >: T] extends AnyRef

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

43. #### class SegmentLength extends Accessor[(Int, Boolean), SegmentLength]

    Attributes
      protected[this]
    Definition Classes
      ParSeqLike

44. #### abstract class SeqComposite [FR, SR, R, First <: StrictSplitterCheckTask[FR, _], Second <: StrictSplitterCheckTask[SR, _]] extends Composite[FR, SR, R, First, Second]

    Sequentially performs one task after another.

45. #### trait SignallingOps [PI <: DelegatedSignalling] extends AnyRef

    Definition Classes
      ParIterableLike

46. #### class Slice [U >: T, This >: Repr] extends Transformer[Combiner[U, This], Slice[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

47. #### class Span [U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), Span[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

48. #### class SplitAt [U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), SplitAt[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

49. #### trait StrictSplitterCheckTask [R, Tp] extends Task[R, Tp]

    Attributes
      protected
    Definition Classes
      ParIterableLike

50. #### class Sum [U >: T] extends Accessor[U, Sum[U]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

51. #### type SuperParIterator = IterableSplitter[Int]

    Definition Classes
      ParSeqLike

52. #### class Take [U >: T, This >: Repr] extends Transformer[Combiner[U, This], Take[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

53. #### class TakeWhile [U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Boolean), TakeWhile[U, This]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

54. #### trait TaskOps [R, Tp] extends AnyRef

    Definition Classes
      ParIterableLike

55. #### class ToParCollection [U >: T, That] extends Transformer[Combiner[U, That], ToParCollection[U, That]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

56. #### class ToParMap [K, V, That] extends Transformer[Combiner[(K, V), That], ToParMap[K, V, That]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

57. #### trait Transformer [R, Tp] extends Accessor[R, Tp] with ParSeqLike.Transformer[R, Tp]

    Attributes
      protected
    Definition Classes
      ParSeqLike → ParIterableLike

58. #### class Updated [U >: T, That] extends Transformer[Combiner[U, That], Updated[U, That]]

    Attributes
      protected[this]
    Definition Classes
      ParSeqLike

59. #### class Zip [U >: T, S, That] extends Transformer[Combiner[(U, S), That], Zip[U, S, That]]

    Attributes
      protected[this]
    Definition Classes
      ParSeqLike → ParIterableLike

60. #### class ZipAll [U >: T, S, That] extends Transformer[Combiner[(U, S), That], ZipAll[U, S, That]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ParRange to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ++[B](that: GenTraversableOnce[B]): ParRange[B]

   [use case] Returns a new immutable parallel range containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new immutable parallel range containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the immutable parallel range is the most specific superclass encompassing the element types of the two operands.

   Example:

       scala> val a = LinkedList(1)
       a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

       scala> val b = LinkedList(2)
       b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val c = a ++ b
       c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

       scala> val d = LinkedList('a')
       d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

       scala> val e = c ++ d
       e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new immutable parallel range which contains all elements of this immutable parallel range followed by all elements of `that`.

   Definition Classes
     ParIterableLike → GenTraversableLike
   Full Signature

   #### def ++[U >: Int, That](that: GenTraversableOnce[U])(implicit bf: CanBuildFrom[ParSeq[Int], U, That]): That

6. #### def +:(elem: A): ParRange[A]

   [use case] A copy of the immutable parallel range with an element prepended.

   [use case]

   A copy of the immutable parallel range with an element prepended.

   Note that :-ending operators are right associative (see example). A mnemonic for `+:` vs. `:+` is: the COLon goes on the COLlection side.

   Also, the original immutable parallel range is not modified, so you will want to capture the result.

   Example:

       scala> val x = LinkedList(1)
       x: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

       scala> val y = 2 +: x
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2, 1)

       scala> println(x)
       LinkedList(1)

   elem

     the prepended element

   returns

     a new immutable parallel range consisting of `elem` followed by all elements of this immutable parallel range.

   Definition Classes
     ParSeqLike → GenSeqLike
   Full Signature

   #### def +:[U >: Int, That](elem: U)(implicit bf: CanBuildFrom[ParSeq[Int], U, That]): That

7. #### def ->[B](y: B): (ParRange, B)

   Implicit information
     This member is added by an implicit conversion from ParRange to ArrowAssoc[ParRange] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline ()

8. #### def /:[S](z: S)(op: (S, Int) ⇒ S): S

   Applies a binary operator to a start value and all elements of this immutable parallel range, going left to right.

   Applies a binary operator to a start value and all elements of this immutable parallel range, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = LinkedList(1,2,3,4)
       a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

       scala> val b = (5 /: a)(_+_)
       b: Int = 15

       scala> val c = (5 /: a)((x,y) => x + y)
       c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this immutable parallel range, going left to right with the start value `z` on the left:

         op(...op(op(z, x_1), x_2), ..., x_n)

     where `x1, ..., xn` are the elements of this immutable parallel range.

   Definition Classes
     ParIterableLike → GenTraversableOnce

9. #### def :+(elem: A): ParRange[A]

   [use case] A copy of this immutable parallel range with an element appended.

   [use case]

   A copy of this immutable parallel range with an element appended.

   A mnemonic for `+:` vs. `:+` is: the COLon goes on the COLlection side.

   Note: will not terminate for infinite-sized collections.

   Example:

       scala> import scala.collection.mutable.LinkedList
       import scala.collection.mutable.LinkedList

       scala> val a = LinkedList(1)
       a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

       scala> val b = a :+ 2
       b: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

       scala> println(a)
       LinkedList(1)

   elem

     the appended element

   returns

     a new immutable parallel range consisting of all elements of this immutable parallel range followed by `elem`.

   Definition Classes
     ParSeqLike → GenSeqLike
   Full Signature

   #### def :+[U >: Int, That](elem: U)(implicit bf: CanBuildFrom[ParSeq[Int], U, That]): That

10. #### def :\[S](z: S)(op: (Int, S) ⇒ S): S

    Applies a binary operator to all elements of this immutable parallel range and a start value, going right to left.

    Applies a binary operator to all elements of this immutable parallel range and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = (a :\ 5)(_+_)
        b: Int = 15

        scala> val c = (a :\ 5)((x,y) => x + y)
        c: Int = 15

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this immutable parallel range, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this immutable parallel range.

    Definition Classes
      ParIterableLike → GenTraversableOnce

11. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

12. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

13. #### def aggregate[S](z: S)(seqop: (S, Int) ⇒ S, combop: (S, S) ⇒ S): S

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

        pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    S

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      ParIterableLike → GenTraversableOnce

14. #### final def apply(idx: Int): Int

    Selects an element by its index in the immutable parallel range.

    Selects an element by its index in the immutable parallel range.

    Example:

        scala> val x = LinkedList(1, 2, 3, 4, 5)
        x: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4, 5)

        scala> x(3)
        res1: Int = 4

    idx

      The index to select.

    returns

      the element of this immutable parallel range at index `idx`, where `0` indicates the first element.

    Definition Classes
      ParRange → ParSeq → GenSeqLike
    Annotations
      @inline ()
    Exceptions thrown
      `IndexOutOfBoundsException`

      if `idx` does not satisfy `0 <= idx < length`.

15. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

16. #### def asParIterable: parallel.ParIterable[Int]

    Implicit information
      This member is added by an implicit conversion from ParRange to TraversableOps[Int] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

17. #### def asParSeq: parallel.ParSeq[Int]

    Implicit information
      This member is added by an implicit conversion from ParRange to TraversableOps[Int] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

18. #### def bf2seq[S, That](bf: CanBuildFrom[ParSeq[Int], S, That]): CanBuildFrom[immutable.Seq[Int], S, That]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

19. #### implicit def builder2ops[Elem, To](cb: Builder[Elem, To]): BuilderOps[Elem, To]

    Attributes
      protected
    Definition Classes
      ParIterableLike

20. #### def canEqual(other: Any): Boolean

    Definition Classes
      ParIterableLike

21. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )
    Note

      not specified by SLS as a member of AnyRef

22. #### def collect[B](pf: PartialFunction[A, B]): ParRange[B]

    [use case] Builds a new collection by applying a partial function to all elements of this immutable parallel range on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this immutable parallel range on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the immutable parallel range.

    returns

      a new immutable parallel range resulting from applying the given partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Full Signature

    #### def collect[S, That](pf: PartialFunction[Int, S])(implicit bf: CanBuildFrom[ParSeq[Int], S, That]): That

23. #### def combinerFactory[S, That](cbf: () ⇒ Combiner[S, That]): CombinerFactory[S, That]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

24. #### def combinerFactory: CombinerFactory[Int, ParSeq[Int]]

    Creates a combiner factory.

    Creates a combiner factory. Each combiner factory instance is used once per invocation of a parallel transformer method for a single collection.

    The default combiner factory creates a new combiner every time it is requested, unless the combiner is thread-safe as indicated by its `canBeShared` method. In this case, the method returns a factory which returns the same combiner each time. This is typically done for concurrent parallel collections, the combiners of which allow thread safe access.

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

25. #### def companion: GenericCompanion[ParSeq] with GenericParCompanion[ParSeq]

    The factory companion object that builds instances of class `immutable.ParRange`.

    The factory companion object that builds instances of class `immutable.ParRange`. (or its `Iterable` superclass where class `immutable.ParRange` is not a `Seq`.)

    Definition Classes
      ParSeq → ParIterable → ParSeq → ParIterable → GenericParTemplate → GenSeq → GenIterable → GenTraversable → GenericTraversableTemplate

26. #### def copyToArray[U >: Int](xs: Array[U], start: Int, len: Int): Unit

    Definition Classes
      ParIterableLike → GenTraversableOnce

27. #### def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this immutable parallel range to an array.

    [use case]

    Copies values of this immutable parallel range to an array. Fills the given array `xs` with values of this immutable parallel range, beginning at index `start`. Copying will stop once either the end of the current immutable parallel range is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Full Signature

    #### def copyToArray[U >: Int](xs: Array[U], start: Int): Unit

28. #### def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this immutable parallel range to an array.

    [use case]

    Copies values of this immutable parallel range to an array. Fills the given array `xs` with values of this immutable parallel range. Copying will stop once either the end of the current immutable parallel range is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Full Signature

    #### def copyToArray[U >: Int](xs: Array[U]): Unit

29. #### def corresponds[S](that: GenSeq[S])(p: (Int, S) ⇒ Boolean): Boolean

    Tests whether every element of this immutable parallel range relates to the corresponding element of another parallel sequence by satisfying a test predicate.

    Tests whether every element of this immutable parallel range relates to the corresponding element of another parallel sequence by satisfying a test predicate.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    S

      the type of the elements of `that`

    that

      the other parallel sequence

    p

      the test predicate, which relates elements from both sequences

    returns

      `true` if both parallel sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this immutable parallel range and `y` of `that`, otherwise `false`

    Definition Classes
      ParSeqLike → GenSeqLike

30. #### def count(p: (Int) ⇒ Boolean): Int

    Counts the number of elements in the immutable parallel range which satisfy a predicate.

    Counts the number of elements in the immutable parallel range which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      ParIterableLike → GenTraversableOnce

31. #### def debugBuffer: ArrayBuffer[String]

    Definition Classes
      ParIterableLike

32. #### implicit def delegatedSignalling2ops[PI <: DelegatedSignalling](it: PI): SignallingOps[PI]

    Attributes
      protected
    Definition Classes
      ParIterableLike

33. #### def diff(that: GenSeq[A]): ParRange[A]

    [use case] Computes the multiset difference between this immutable parallel range and another sequence.

    [use case]

    Computes the multiset difference between this immutable parallel range and another sequence.

    Note: will not terminate for infinite-sized collections.

    that

      the sequence of elements to remove

    returns

      a new immutable parallel range which contains all elements of this immutable parallel range except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      ParSeqLike → GenSeqLike
    Full Signature

    #### def diff[U >: Int](that: GenSeq[U]): ParSeq[Int]

34. #### def distinct: ParSeq[Int]

    Builds a new immutable parallel range from this immutable parallel range without any duplicate elements.

    Builds a new immutable parallel range from this immutable parallel range without any duplicate elements.

    Note: will not terminate for infinite-sized collections.

    returns

      A new immutable parallel range which contains the first occurrence of every element of this immutable parallel range.

    Definition Classes
      ParSeqLike → GenSeqLike

35. #### def down(p: IterableSplitter[_]): SeqSplitter[Int]

    Attributes
      protected[this]
    Definition Classes
      ParSeqLike

36. #### def drop(n: Int): ParSeq[Int]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to drop from this immutable parallel range.

    returns

      a immutable parallel range consisting of all elements of this immutable parallel range except the first `n` ones, or else the empty immutable parallel range, if this immutable parallel range has less than `n` elements.

    Definition Classes
      ParIterableLike → GenTraversableLike

37. #### def dropWhile(pred: (Int) ⇒ Boolean): ParSeq[Int]

    Drops all elements in the longest prefix of elements that satisfy the predicate, and returns a collection composed of the remaining elements.

    Drops all elements in the longest prefix of elements that satisfy the predicate, and returns a collection composed of the remaining elements.

    This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

    pred

      the predicate used to test the elements

    returns

      a collection composed of all the elements after the longest prefix of elements in this immutable parallel range that satisfy the predicate `pred`

    Definition Classes
      ParIterableLike → GenTraversableLike

38. #### def endsWith[S](that: GenSeq[S]): Boolean

    Tests whether this immutable parallel range ends with the given parallel sequence.

    Tests whether this immutable parallel range ends with the given parallel sequence.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    S

      the type of the elements of `that` sequence

    that

      the sequence to test

    returns

      `true` if this immutable parallel range has `that` as a suffix, `false` otherwise

    Definition Classes
      ParSeqLike → GenSeqLike

39. #### def ensuring(cond: (ParRange) ⇒ Boolean, msg: ⇒ Any): ParRange

    Implicit information
      This member is added by an implicit conversion from ParRange to Ensuring[ParRange] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

40. #### def ensuring(cond: (ParRange) ⇒ Boolean): ParRange

    Implicit information
      This member is added by an implicit conversion from ParRange to Ensuring[ParRange] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

41. #### def ensuring(cond: Boolean, msg: ⇒ Any): ParRange

    Implicit information
      This member is added by an implicit conversion from ParRange to Ensuring[ParRange] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

42. #### def ensuring(cond: Boolean): ParRange

    Implicit information
      This member is added by an implicit conversion from ParRange to Ensuring[ParRange] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

43. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

44. #### def equals(that: Any): Boolean

    The equals method for arbitrary sequences.

    The equals method for arbitrary sequences. Compares this sequence to some other object.

    that

      The object to compare the sequence to

    returns

      `true` if `that` is a sequence that has the same elements as this sequence in the same order, `false` otherwise

    Definition Classes
      GenSeqLike → Equals → Any

45. #### def exists(pred: (Int) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some element of this immutable parallel range.

    Tests whether a predicate holds for some element of this immutable parallel range.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    pred

      a predicate used to test elements

    returns

      true if `p` holds for some element, false otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

46. #### def filter(pred: (Int) ⇒ Boolean): ParSeq[Int]

    Selects all elements of this immutable parallel range which satisfy a predicate.

    Selects all elements of this immutable parallel range which satisfy a predicate.

    pred

      the predicate used to test elements.

    returns

      a new immutable parallel range consisting of all elements of this immutable parallel range that satisfy the given predicate `p`. Their order may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

47. #### def filterNot(pred: (Int) ⇒ Boolean): ParSeq[Int]

    Selects all elements of this immutable parallel range which do not satisfy a predicate.

    Selects all elements of this immutable parallel range which do not satisfy a predicate.

    pred

      the predicate used to test elements.

    returns

      a new immutable parallel range consisting of all elements of this immutable parallel range that do not satisfy the given predicate `p`. Their order may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

48. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

49. #### def find(pred: (Int) ⇒ Boolean): Option[Int]

    Finds some element in the collection for which the predicate holds, if such an element exists.

    Finds some element in the collection for which the predicate holds, if such an element exists. The element may not necessarily be the first such element in the iteration order.

    If there are multiple elements obeying the predicate, the choice is nondeterministic.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    pred

      predicate used to test the elements

    returns

      an option value with the element if such an element exists, or `None` otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

50. #### def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): ParRange[B]

    [use case] Builds a new collection by applying a function to all elements of this immutable parallel range and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this immutable parallel range and using the elements of the resulting collections.

    For example:

        def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of immutable parallel range. This might cause unexpected results sometimes. For example:

        // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
        def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

        // lettersOf will return a Set[Char], not a Seq
        def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

        // xs will be a an Iterable[Int]
        val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

        // ys will be a Map[Int, Int]
        val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new immutable parallel range resulting from applying the given collection-valued function `f` to each element of this immutable parallel range and concatenating the results.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Full Signature

    #### def flatMap[S, That](f: (Int) ⇒ GenTraversableOnce[S])(implicit bf: CanBuildFrom[ParSeq[Int], S, That]): That

51. #### def flatten[B]: ParRange[B]

    [use case] Converts this immutable parallel range of traversable collections into a immutable parallel range formed by the elements of these traversable collections.

    [use case]

    Converts this immutable parallel range of traversable collections into a immutable parallel range formed by the elements of these traversable collections.

    The resulting collection's type will be guided by the static type of immutable parallel range. For example:

        val xs = List(Set(1, 2, 3), Set(1, 2, 3))
        // xs == List(1, 2, 3, 1, 2, 3)

        val ys = Set(List(1, 2, 3), List(3, 2, 1))
        // ys == Set(1, 2, 3)

    B

      the type of the elements of each traversable collection.

    returns

      a new immutable parallel range resulting from concatenating all element immutable parallel ranges.

    Definition Classes
      GenericTraversableTemplate
    Full Signature

    #### def flatten[B](implicit asTraversable: (Int) ⇒ GenTraversableOnce[B]): ParSeq[B]

52. #### def fold[U >: Int](z: U)(op: (U, U) ⇒ U): U

    Folds the elements of this sequence using the specified associative binary operator.

    Folds the elements of this sequence using the specified associative binary operator. The order in which the elements are reduced is unspecified and may be nondeterministic.

    Note this method has a different signature than the `foldLeft` and `foldRight` methods of the trait `Traversable`. The result of folding may only be a supertype of this parallel collection's type parameter `T`.

    U

      a type parameter for the binary operator, a supertype of `T`.

    z

      a neutral element for the fold operation, it may be added to the result an arbitrary number of times, not changing the result (e.g. `Nil` for list concatenation, 0 for addition, or 1 for multiplication)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      ParIterableLike → GenTraversableOnce

53. #### def foldLeft[S](z: S)(op: (S, Int) ⇒ S): S

    Applies a binary operator to a start value and all elements of this immutable parallel range, going left to right.

    Applies a binary operator to a start value and all elements of this immutable parallel range, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this immutable parallel range, going left to right with the start value `z` on the left:

          op(...op(z, x_1), x_2, ..., x_n)

      where `x1, ..., xn` are the elements of this immutable parallel range.

    Definition Classes
      ParIterableLike → GenTraversableOnce

54. #### def foldRight[S](z: S)(op: (Int, S) ⇒ S): S

    Applies a binary operator to all elements of this immutable parallel range and a start value, going right to left.

    Applies a binary operator to all elements of this immutable parallel range and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this immutable parallel range, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this immutable parallel range.

    Definition Classes
      ParIterableLike → GenTraversableOnce

55. #### def forall(pred: (Int) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this immutable parallel range.

    Tests whether a predicate holds for all elements of this immutable parallel range.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    pred

      a predicate used to test elements

    returns

      true if `p` holds for all elements, false otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

56. #### def foreach[U](f: (Int) ⇒ U): Unit

    Applies a function `f` to all the elements of immutable parallel range in a undefined order.

    Applies a function `f` to all the elements of immutable parallel range in a undefined order.

    U

      the result type of the function applied to each element, which is always discarded

    f

      function applied to each element

    Definition Classes
      ParIterableLike → GenTraversableLike → GenTraversableOnce

57. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from ParRange to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline ()

58. #### def genericBuilder[B]: Combiner[B, ParSeq[B]]

    The generic builder that builds instances of `immutable.ParRange` at arbitrary element types.

    The generic builder that builds instances of `immutable.ParRange` at arbitrary element types.

    Definition Classes
      GenericParTemplate → GenericTraversableTemplate

59. #### def genericCombiner[B]: Combiner[B, ParSeq[B]]

    Definition Classes
      GenericParTemplate

60. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

61. #### def groupBy[K](f: (Int) ⇒ K): ParMap[K, ParSeq[Int]]

    Partitions this immutable parallel range into a map of immutable parallel ranges according to some discriminator function.

    Partitions this immutable parallel range into a map of immutable parallel ranges according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new immutable parallel range.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to immutable parallel ranges such that the following invariant holds:

          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a immutable parallel range of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      ParIterableLike → GenTraversableLike

62. #### def hasDefiniteSize: Boolean

    Definition Classes
      ParIterableLike → GenTraversableOnce

63. #### def hashCode(): Int

    Hashcodes for `immutable.ParRange` produce a value from the hashcodes of all the elements of the immutable parallel range.

    Hashcodes for `immutable.ParRange` produce a value from the hashcodes of all the elements of the immutable parallel range.

    returns

      the hash code value for this object.

    Definition Classes
      GenSeqLike → Any

64. #### def head: Int

    Selects the first element of this immutable parallel range.

    Selects the first element of this immutable parallel range.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this immutable parallel range.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the immutable parallel range is empty.

65. #### def headOption: Option[Int]

    Optionally selects the first element.

    Optionally selects the first element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this immutable parallel range if it is nonempty, `None` if it is empty.

    Definition Classes
      ParIterableLike → GenTraversableLike

66. #### def ifParSeq[R](isbody: (parallel.ParSeq[Int]) ⇒ R): (TraversableOps[Int])#Otherwise[R]

    Implicit information
      This member is added by an implicit conversion from ParRange to TraversableOps[Int] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

67. #### def indexOf(elem: Int, from: Int): Int

    [use case] Finds index of first occurrence of some value in this immutable parallel range after or at some start index.

    [use case]

    Finds index of first occurrence of some value in this immutable parallel range after or at some start index.

    Note: may not terminate for infinite-sized collections.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this immutable parallel range that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def indexOf[B >: Int](elem: B, from: Int): Int

68. #### def indexOf(elem: Int): Int

    [use case] Finds index of first occurrence of some value in this immutable parallel range.

    [use case]

    Finds index of first occurrence of some value in this immutable parallel range.

    Note: may not terminate for infinite-sized collections.

    elem

      the element value to search for.

    returns

      the index of the first element of this immutable parallel range that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def indexOf[B >: Int](elem: B): Int

69. #### def indexWhere(p: (Int) ⇒ Boolean, from: Int): Int

    Finds the first element satisfying some predicate.

    Finds the first element satisfying some predicate.

    This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state.

    The index flag is initially set to maximum integer value.

    p

      the predicate used to test the elements

    from

      the starting offset for the search

    returns

      the index `>= from` of the first element of this immutable parallel range that satisfies the predicate `p`, or `-1`, if none exists

    Definition Classes
      ParSeqLike → GenSeqLike

70. #### def indexWhere(p: (Int) ⇒ Boolean): Int

    Finds index of first element satisfying some predicate.

    Finds index of first element satisfying some predicate.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      the index of the first element of this immutable parallel range that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

71. #### def init: ParSeq[Int]

    Selects all elements except the last.

    Selects all elements except the last.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a immutable parallel range consisting of all elements of this immutable parallel range except the last one.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Exceptions thrown
      `UnsupportedOperationException`

      if the immutable parallel range is empty.

72. #### def initTaskSupport(): Unit

    Attributes
      protected
    Definition Classes
      ParIterableLike

73. #### def intersect(that: scala.Seq[Int]): ParRange[Int]

    [use case] Computes the multiset intersection between this immutable parallel range and another sequence.

    [use case]

    Computes the multiset intersection between this immutable parallel range and another sequence.

    Note: may not terminate for infinite-sized collections.

    that

      the sequence of elements to intersect with.

    returns

      a new immutable parallel range which contains all elements of this immutable parallel range which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      ParSeqLike → GenSeqLike
    Full Signature

    #### def intersect[U >: Int](that: GenSeq[U]): ParSeq[Int]

74. #### def isDefinedAt(idx: Int): Boolean

    Tests whether this immutable parallel range contains given index.

    Tests whether this immutable parallel range contains given index.

    The implementations of methods `apply` and `isDefinedAt` turn a `Seq[A]` into a `PartialFunction[Int, A]`.

    idx

      the index to test

    returns

      `true` if this immutable parallel range contains an element at position `idx`, `false` otherwise.

    Definition Classes
      GenSeqLike

75. #### def isEmpty: Boolean

    Tests whether the immutable parallel range is empty.

    Tests whether the immutable parallel range is empty.

    returns

      `true` if the immutable parallel range contains no elements, `false` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce

76. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

77. #### def isParIterable: Boolean

    Implicit information
      This member is added by an implicit conversion from ParRange to TraversableOps[Int] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

78. #### def isParSeq: Boolean

    Implicit information
      This member is added by an implicit conversion from ParRange to TraversableOps[Int] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

79. #### def isParallel: Boolean

    Implicit information
      This member is added by an implicit conversion from ParRange to TraversableOps[Int] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

80. #### def isStrictSplitterCollection: Boolean

    Denotes whether this parallel collection has strict splitters.

    Denotes whether this parallel collection has strict splitters.

    This is true in general, and specific collection instances may choose to override this method. Such collections will fail to execute methods which rely on splitters being strict, i.e. returning a correct value in the `remaining` method.

    This method helps ensure that such failures occur on method invocations, rather than later on and in unpredictable ways.

    Definition Classes
      ParIterableLike

81. #### final def isTraversableAgain: Boolean

    Tests whether this immutable parallel range can be repeatedly traversed.

    Tests whether this immutable parallel range can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      ParIterableLike → GenTraversableLike → GenTraversableOnce

82. #### def iterator: PreciseSplitter[Int]

    Creates a new split iterator used to traverse the elements of this collection.

    Creates a new split iterator used to traverse the elements of this collection.

    By default, this method is implemented in terms of the protected `splitter` method.

    returns

      a split iterator

    Definition Classes
      ParSeqLike → ParIterableLike → GenIterableLike

83. #### def last: Int

    Selects the last element.

    Selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      The last element of this immutable parallel range.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Exceptions thrown
      NoSuchElementException

      If the immutable parallel range is empty.

84. #### def lastIndexOf(elem: Int, end: Int): Int

    [use case] Finds index of last occurrence of some value in this immutable parallel range before or at a given end index.

    [use case]

    Finds index of last occurrence of some value in this immutable parallel range before or at a given end index.

    elem

      the element value to search for.

    end

      the end index.

    returns

      the index `<= end` of the last element of this immutable parallel range that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def lastIndexOf[B >: Int](elem: B, end: Int): Int

85. #### def lastIndexOf(elem: Int): Int

    [use case] Finds index of last occurrence of some value in this immutable parallel range.

    [use case]

    Finds index of last occurrence of some value in this immutable parallel range.

    Note: will not terminate for infinite-sized collections.

    elem

      the element value to search for.

    returns

      the index of the last element of this immutable parallel range that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def lastIndexOf[B >: Int](elem: B): Int

86. #### def lastIndexWhere(p: (Int) ⇒ Boolean, end: Int): Int

    Finds the last element satisfying some predicate.

    Finds the last element satisfying some predicate.

    This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state.

    The index flag is initially set to minimum integer value.

    p

      the predicate used to test the elements

    end

      the maximum offset for the search

    returns

      the index `<= end` of the first element of this immutable parallel range that satisfies the predicate `p`, or `-1`, if none exists

    Definition Classes
      ParSeqLike → GenSeqLike

87. #### def lastIndexWhere(p: (Int) ⇒ Boolean): Int

    Finds index of last element satisfying some predicate.

    Finds index of last element satisfying some predicate.

    Note: will not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      the index of the last element of this immutable parallel range that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

88. #### def lastOption: Option[Int]

    Optionally selects the last element.

    Optionally selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the last element of this immutable parallel range$ if it is nonempty, `None` if it is empty.

    Definition Classes
      ParIterableLike → GenTraversableLike

89. #### final def length: Int

    The length of the immutable parallel range.

    The length of the immutable parallel range.

    Note: will not terminate for infinite-sized collections.

    Note: `xs.length` and `xs.size` yield the same result.

    returns

      the number of elements in this immutable parallel range.

    Definition Classes
      ParRange → GenSeqLike
    Annotations
      @inline ()

90. #### def map[B](f: (A) ⇒ B): ParRange[B]

    [use case] Builds a new collection by applying a function to all elements of this immutable parallel range.

    [use case]

    Builds a new collection by applying a function to all elements of this immutable parallel range.

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new immutable parallel range resulting from applying the given function `f` to each element of this immutable parallel range and collecting the results.

    Definition Classes
      ParIterableLike → GenTraversableLike
    Full Signature

    #### def map[S, That](f: (Int) ⇒ S)(implicit bf: CanBuildFrom[ParSeq[Int], S, That]): That

91. #### def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this immutable parallel range.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Full Signature

    #### def max[U >: Int](implicit ord: Ordering[U]): Int

92. #### def maxBy[S](f: (Int) ⇒ S)(implicit cmp: Ordering[S]): Int

    Definition Classes
      ParIterableLike → GenTraversableOnce

93. #### def min: A

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this immutable parallel range

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Full Signature

    #### def min[U >: Int](implicit ord: Ordering[U]): Int

94. #### def minBy[S](f: (Int) ⇒ S)(implicit cmp: Ordering[S]): Int

    Definition Classes
      ParIterableLike → GenTraversableOnce

95. #### def mkString: String

    Displays all elements of this immutable parallel range in a string.

    Displays all elements of this immutable parallel range in a string.

    returns

      a string representation of this immutable parallel range. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this immutable parallel range follow each other without any separator string.

    Definition Classes
      ParIterableLike → GenTraversableOnce

96. #### def mkString(sep: String): String

    Displays all elements of this immutable parallel range in a string using a separator string.

    Displays all elements of this immutable parallel range in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this immutable parallel range. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this immutable parallel range are separated by the string `sep`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

97. #### def mkString(start: String, sep: String, end: String): String

    Displays all elements of this immutable parallel range in a string using start, end, and separator strings.

    Displays all elements of this immutable parallel range in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this immutable parallel range. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this immutable parallel range are separated by the string `sep`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

98. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

99. #### def newBuilder: Builder[Int, ParSeq[Int]]

    The builder that builds instances of type `immutable.ParRange`[A]

    The builder that builds instances of type `immutable.ParRange`[A]

    Attributes
      protected[this]
    Definition Classes
      GenericParTemplate → GenericTraversableTemplate → HasNewBuilder

100. #### def newCombiner: Combiner[Int, ParSeq[Int]]

     Attributes
       protected[this]
     Definition Classes
       GenericParTemplate → HasNewCombiner

101. #### def nonEmpty: Boolean

     Tests whether the immutable parallel range is not empty.

     Tests whether the immutable parallel range is not empty.

     returns

       `true` if the immutable parallel range contains at least one element, `false` otherwise.

     Definition Classes
       ParIterableLike → GenTraversableOnce

102. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

103. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

104. #### def padTo(len: Int, elem: A): ParRange[A]

     [use case] A copy of this immutable parallel range with an element value appended until a given target length is reached.

     [use case]

     A copy of this immutable parallel range with an element value appended until a given target length is reached.

     len

       the target length

     elem

       the padding value

     returns

       a new immutable parallel range consisting of all elements of this immutable parallel range followed by the minimal number of occurrences of `elem` so that the resulting immutable parallel range has a length of at least `len`.

     Definition Classes
       ParSeqLike → GenSeqLike
     Full Signature

     #### def padTo[U >: Int, That](len: Int, elem: U)(implicit bf: CanBuildFrom[ParSeq[Int], U, That]): That

105. #### def par: ParSeq[Int]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       ParIterableLike → CustomParallelizable → Parallelizable

106. #### def parCombiner: Combiner[Int, ParSeq[Int]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       CustomParallelizable → Parallelizable

107. #### def partition(pred: (Int) ⇒ Boolean): (ParSeq[Int], ParSeq[Int])

     Partitions this immutable parallel range in two immutable parallel ranges according to a predicate.

     Partitions this immutable parallel range in two immutable parallel ranges according to a predicate.

     pred

       the predicate on which to partition.

     returns

       a pair of immutable parallel ranges: the first immutable parallel range consists of all elements that satisfy the predicate `p` and the second immutable parallel range consists of all elements that don't. The relative order of the elements in the resulting immutable parallel ranges may not be preserved.

     Definition Classes
       ParIterableLike → GenTraversableLike

108. #### def patch(from: Int, that: GenSeq[A], replaced: Int): ParRange[A]

     [use case] Produces a new immutable parallel range where a slice of elements in this immutable parallel range is replaced by another sequence.

     [use case]

     Produces a new immutable parallel range where a slice of elements in this immutable parallel range is replaced by another sequence.

     from

       the index of the first replaced element

     replaced

       the number of elements to drop in the original immutable parallel range

     returns

       a new immutable parallel range consisting of all elements of this immutable parallel range except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       ParSeqLike → GenSeqLike
     Full Signature

     #### def patch[U >: Int, That](from: Int, patch: GenSeq[U], replaced: Int)(implicit bf: CanBuildFrom[ParSeq[Int], U, That]): That

109. #### def prefixLength(p: (Int) ⇒ Boolean): Int

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Note: may not terminate for infinite-sized collections.

     p

       the predicate used to test elements.

     returns

       the length of the longest prefix of this immutable parallel range such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       GenSeqLike

110. #### def product: A

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements in this immutable parallel range of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the immutable parallel range and as result type of `product`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       ParIterableLike → GenTraversableOnce
     Full Signature

     #### def product[U >: Int](implicit num: Numeric[U]): U

111. #### val range: immutable.Range

     the sequential range this parallel range was obtained from

112. #### def reduce[U >: Int](op: (U, U) ⇒ U): U

     Reduces the elements of this sequence using the specified associative binary operator.

     Reduces the elements of this sequence using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     Note this method has a different signature than the `reduceLeft` and `reduceRight` methods of the trait `Traversable`. The result of reducing may only be a supertype of this parallel collection's type parameter `T`.

     U

       A type parameter for the binary operator, a supertype of `T`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the collection is nonempty.

     Definition Classes
       ParIterableLike → GenTraversableOnce
     Exceptions thrown
       UnsupportedOperationException

       if this immutable parallel range is empty.

113. #### def reduceLeft[U >: Int](op: (U, Int) ⇒ U): U

     Definition Classes
       ParIterableLike

114. #### def reduceLeftOption[U >: Int](op: (U, Int) ⇒ U): Option[U]

     Optionally applies a binary operator to all elements of this immutable parallel range, going left to right.

     Optionally applies a binary operator to all elements of this immutable parallel range, going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this immutable parallel range is nonempty, `None` otherwise.

     Definition Classes
       ParIterableLike → GenTraversableOnce

115. #### def reduceOption[U >: Int](op: (U, U) ⇒ U): Option[U]

     Optionally reduces the elements of this sequence using the specified associative binary operator.

     Optionally reduces the elements of this sequence using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     Note this method has a different signature than the `reduceLeftOption` and `reduceRightOption` methods of the trait `Traversable`. The result of reducing may only be a supertype of this parallel collection's type parameter `T`.

     U

       A type parameter for the binary operator, a supertype of `T`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       ParIterableLike → GenTraversableOnce

116. #### def reduceRight[U >: Int](op: (Int, U) ⇒ U): U

     Applies a binary operator to all elements of this immutable parallel range, going right to left.

     Applies a binary operator to all elements of this immutable parallel range, going right to left.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this immutable parallel range, going right to left:

           op(x_1, op(x_2, ..., op(x_{n-1}, x_n)...))

       where `x1, ..., xn` are the elements of this immutable parallel range.

     Definition Classes
       ParIterableLike → GenTraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this immutable parallel range is empty.

117. #### def reduceRightOption[U >: Int](op: (Int, U) ⇒ U): Option[U]

     Optionally applies a binary operator to all elements of this immutable parallel range, going right to left.

     Optionally applies a binary operator to all elements of this immutable parallel range, going right to left.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this immutable parallel range is nonempty, `None` otherwise.

     Definition Classes
       ParIterableLike → GenTraversableOnce

118. #### def repr: ParSeq[Int]

     Definition Classes
       ParIterableLike → GenTraversableLike

119. #### def reuse[S, That](oldc: Option[Combiner[S, That]], newc: Combiner[S, That]): Combiner[S, That]

     Optionally reuses an existing combiner for better performance.

     Optionally reuses an existing combiner for better performance. By default it doesn't - subclasses may override this behaviour. The provided combiner `oldc` that can potentially be reused will be either some combiner from the previous computational task, or `None` if there was no previous phase (in which case this method must return `newc`).

     oldc

       The combiner that is the result of the previous task, or `None` if there was no previous task.

     newc

       The new, empty combiner that can be used.

     returns

       Either `newc` or `oldc`.

     Attributes
       protected
     Definition Classes
       ParIterableLike

120. #### def reverse: ParSeq[Int]

     Returns new immutable parallel range wih elements in reversed order.

     Returns new immutable parallel range wih elements in reversed order.

     Note: will not terminate for infinite-sized collections.

     returns

       A new immutable parallel range with all elements of this immutable parallel range in reversed order.

     Definition Classes
       ParSeqLike → GenSeqLike

121. #### def reverseMap[B](f: (A) ⇒ B): ParRange[B]

     [use case] Builds a new collection by applying a function to all elements of this immutable parallel range and collecting the results in reversed order.

     [use case]

     Builds a new collection by applying a function to all elements of this immutable parallel range and collecting the results in reversed order.

     Note: will not terminate for infinite-sized collections.

     Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new immutable parallel range resulting from applying the given function `f` to each element of this immutable parallel range and collecting the results in reversed order.

     Definition Classes
       ParSeqLike → GenSeqLike
     Full Signature

     #### def reverseMap[S, That](f: (Int) ⇒ S)(implicit bf: CanBuildFrom[ParSeq[Int], S, That]): That

122. #### def sameElements(that: GenIterable[A]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this immutable parallel range.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this immutable parallel range.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Note: will not terminate for infinite-sized collections.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       ParSeqLike → ParIterableLike → GenIterableLike
     Full Signature

     #### def sameElements[U >: Int](that: GenIterable[U]): Boolean

123. #### def scan(z: Int)(op: (Int, Int) ⇒ Int): ParRange[Int]

     [use case] Computes a prefix scan of the elements of the collection.

     [use case]

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     returns

       a new immutable parallel range containing the prefix scan of the elements in this immutable parallel range

     Definition Classes
       ParIterableLike → GenTraversableLike
     Full Signature

     #### def scan[U >: Int, That](z: U)(op: (U, U) ⇒ U)(implicit bf: CanBuildFrom[ParSeq[Int], U, That]): That

124. #### def scanBlockSize: Int

     Attributes
       protected[this]
     Definition Classes
       ParIterableLike

125. #### def scanLeft[S, That](z: S)(op: (S, Int) ⇒ S)(implicit bf: CanBuildFrom[ParSeq[Int], S, That]): That

     Produces a collection containing cumulative results of applying the operator going left to right.

     Produces a collection containing cumulative results of applying the operator going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       ParIterableLike → GenTraversableLike

126. #### def scanRight[S, That](z: S)(op: (Int, S) ⇒ S)(implicit bf: CanBuildFrom[ParSeq[Int], S, That]): That

     Produces a collection containing cumulative results of applying the operator going right to left.

     Produces a collection containing cumulative results of applying the operator going right to left. The head of the collection is the last cumulative result.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Example:

         List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       ParIterableLike → GenTraversableLike

127. #### def segmentLength(p: (Int) ⇒ Boolean, from: Int): Int

     Returns the length of the longest segment of elements starting at a given position satisfying some predicate.

     Returns the length of the longest segment of elements starting at a given position satisfying some predicate.

     This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state.

     The index flag is initially set to maximum integer value.

     p

       the predicate used to test the elements

     from

       the starting offset for the search

     returns

       the length of the longest segment of elements starting at `from` and satisfying the predicate

     Definition Classes
       ParSeqLike → GenSeqLike

128. #### def seq: immutable.Range

     Definition Classes
       ParRange → ParIterableLike → GenSeq → GenIterable → GenTraversable → GenSeqLike → Parallelizable → GenTraversableOnce

129. #### def sequentially[S, That <: Parallel](b: (immutable.Seq[Int]) ⇒ Parallelizable[S, That]): ParSeq[Int]

     Attributes
       protected[this]
     Definition Classes
       ParIterableLike

130. #### def size: Int

     The size of this immutable parallel range.

     The size of this immutable parallel range.

     Note: will not terminate for infinite-sized collections.

     returns

       the number of elements in this immutable parallel range.

     Definition Classes
       ParSeqLike → GenTraversableLike → GenTraversableOnce

131. #### def slice(unc_from: Int, unc_until: Int): ParSeq[Int]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

         from <= indexOf(x) < until

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     unc_from

       the lowest index to include from this immutable parallel range.

     unc_until

       the lowest index to EXCLUDE from this immutable parallel range.

     returns

       a immutable parallel range containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this immutable parallel range.

     Definition Classes
       ParIterableLike → GenTraversableLike

132. #### def span(pred: (Int) ⇒ Boolean): (ParSeq[Int], ParSeq[Int])

     Splits this immutable parallel range into a prefix/suffix pair according to a predicate.

     Splits this immutable parallel range into a prefix/suffix pair according to a predicate.

     This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

     pred

       the predicate used to test the elements

     returns

       a pair consisting of the longest prefix of the collection for which all the elements satisfy `pred`, and the rest of the collection

     Definition Classes
       ParIterableLike → GenTraversableLike

133. #### def splitAt(n: Int): (ParSeq[Int], ParSeq[Int])

     Splits this immutable parallel range into two at a given position.

     Splits this immutable parallel range into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the position at which to split.

     returns

       a pair of immutable parallel ranges consisting of the first `n` elements of this immutable parallel range, and the other elements.

     Definition Classes
       ParIterableLike → GenTraversableLike

134. #### def splitter: ParRangeIterator

     A more refined version of the iterator found in the `ParallelIterable` trait, this iterator can be split into arbitrary subsets of iterators.

     A more refined version of the iterator found in the `ParallelIterable` trait, this iterator can be split into arbitrary subsets of iterators.

     returns

       an iterator that can be split into subsets of precise size

     Definition Classes
       ParRange → ParSeqLike → ParIterableLike

135. #### def startsWith[S](that: GenSeq[S], offset: Int): Boolean

     Tests whether this immutable parallel range contains the given sequence at a given index.

     Tests whether this immutable parallel range contains the given sequence at a given index.

     This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

     S

       the element type of `that` parallel sequence

     that

       the parallel sequence this sequence is being searched for

     offset

       the starting offset for the search

     returns

       `true` if there is a sequence `that` starting at `offset` in this sequence, `false` otherwise

     Definition Classes
       ParSeqLike → GenSeqLike

136. #### def startsWith[B](that: GenSeq[B]): Boolean

     Tests whether this immutable parallel range starts with the given sequence.

     Tests whether this immutable parallel range starts with the given sequence.

     that

       the sequence to test

     returns

       `true` if this collection has `that` as a prefix, `false` otherwise.

     Definition Classes
       GenSeqLike

137. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this immutable parallel range. By default the string prefix is the simple name of the collection class immutable parallel range.

     Definition Classes
       ParSeq → ParIterable → GenTraversableLike

138. #### def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements in this immutable parallel range of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the immutable parallel range and as result type of `sum`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       ParIterableLike → GenTraversableOnce
     Full Signature

     #### def sum[U >: Int](implicit num: Numeric[U]): U

139. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

140. #### def tail: ParSeq[Int]

     Selects all elements except the first.

     Selects all elements except the first.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a immutable parallel range consisting of all elements of this immutable parallel range except the first one.

     Definition Classes
       ParIterableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the immutable parallel range is empty.

141. #### def take(n: Int): ParSeq[Int]

     Selects first n elements.

     Selects first n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the number of elements to take from this immutable parallel range.

     returns

       a immutable parallel range consisting only of the first `n` elements of this immutable parallel range, or else the whole immutable parallel range, if it has less than `n` elements.

     Definition Classes
       ParIterableLike → GenTraversableLike

142. #### def takeWhile(pred: (Int) ⇒ Boolean): ParSeq[Int]

     Takes the longest prefix of elements that satisfy the predicate.

     Takes the longest prefix of elements that satisfy the predicate.

     This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

     pred

       the predicate used to test the elements

     returns

       the longest prefix of this immutable parallel range of elements that satisy the predicate `pred`

     Definition Classes
       ParIterableLike → GenTraversableLike

143. #### implicit def task2ops[R, Tp](tsk: SSCTask[R, Tp]): TaskOps[R, Tp]

     Attributes
       protected
     Definition Classes
       ParIterableLike

144. #### def tasksupport: TaskSupport

     The task support object which is responsible for scheduling and load-balancing tasks to processors.

     The task support object which is responsible for scheduling and load-balancing tasks to processors.

     Definition Classes
       ParIterableLike
     See also

       scala.collection.parallel.TaskSupport

145. #### def tasksupport_=(ts: TaskSupport): Unit

     Changes the task support object which is responsible for scheduling and load-balancing tasks to processors.

     Changes the task support object which is responsible for scheduling and load-balancing tasks to processors.

     A task support object can be changed in a parallel collection after it has been created, but only during a quiescent period, i.e. while there are no concurrent invocations to parallel collection methods.

     Here is a way to change the task support of a parallel collection:

         import scala.collection.parallel._
         val pc = mutable.ParArray(1, 2, 3)
         pc.tasksupport = new ForkJoinTaskSupport(
           new scala.concurrent.forkjoin.ForkJoinPool(2))

     Definition Classes
       ParIterableLike
     See also

       scala.collection.parallel.TaskSupport

146. #### def to[Col[_]]: Col[A]

     [use case] Converts this immutable parallel range into another by copying all elements.

     [use case]

     Converts this immutable parallel range into another by copying all elements.

     Note: will not terminate for infinite-sized collections.

     Col

       The collection type to build.

     returns

       a new collection containing all elements of this immutable parallel range.

     Definition Classes
       ParIterableLike → GenTraversableOnce
     Full Signature

     #### def to[Col[_]](implicit cbf: CanBuildFrom[Nothing, Int, Col[Int]]): Col[Int]

147. #### def toArray: Array[A]

     [use case] Converts this immutable parallel range to an array.

     [use case]

     Converts this immutable parallel range to an array.

     Note: will not terminate for infinite-sized collections.

     returns

       an array containing all elements of this immutable parallel range. An `ClassTag` must be available for the element type of this immutable parallel range.

     Definition Classes
       ParIterableLike → GenTraversableOnce
     Full Signature

     #### def toArray[U >: Int](implicit arg0: ClassTag[U]): Array[U]

148. #### def toBuffer[U >: Int]: Buffer[U]

     Converts this immutable parallel range to a mutable buffer.

     Converts this immutable parallel range to a mutable buffer.

     Note: will not terminate for infinite-sized collections.

     returns

       a buffer containing all elements of this immutable parallel range.

     Definition Classes
       ParIterableLike → GenTraversableOnce

149. #### def toIndexedSeq: immutable.IndexedSeq[Int]

     Converts this immutable parallel range to an indexed sequence.

     Converts this immutable parallel range to an indexed sequence.

     Note: will not terminate for infinite-sized collections.

     returns

       an indexed sequence containing all elements of this immutable parallel range.

     Definition Classes
       ParIterableLike → GenTraversableOnce

150. #### def toIterable: ParIterable[Int]

     Converts this immutable parallel range to an iterable collection.

     Converts this immutable parallel range to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     Note: will not terminate for infinite-sized collections.

     returns

       an `Iterable` containing all elements of this immutable parallel range.

     Definition Classes
       ParIterable → ParIterableLike → GenTraversableOnce

151. #### def toIterator: scala.Iterator[Int]

     Returns an Iterator over the elements in this immutable parallel range.

     Returns an Iterator over the elements in this immutable parallel range. Will return the same Iterator if this instance is already an Iterator.

     Note: will not terminate for infinite-sized collections.

     returns

       an Iterator containing all elements of this immutable parallel range.

     Definition Classes
       ParIterableLike → GenTraversableOnce

152. #### def toList: List[Int]

     Converts this immutable parallel range to a list.

     Converts this immutable parallel range to a list.

     Note: will not terminate for infinite-sized collections.

     returns

       a list containing all elements of this immutable parallel range.

     Definition Classes
       ParIterableLike → GenTraversableOnce

153. #### def toMap[T, U]: collection.Map[T, U]

     [use case] Converts this immutable parallel range to a map.

     [use case]

     Converts this immutable parallel range to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map of type `immutable.Map[T, U]` containing all key/value pairs of type `(T, U)` of this immutable parallel range.

     Definition Classes
       ParIterableLike → GenTraversableOnce
     Full Signature

     #### def toMap[K, V](implicit ev: <:<[Int, (K, V)]): ParMap[K, V]

154. #### def toParArray: ParArray[Int]

     Implicit information
       This member is added by an implicit conversion from ParRange to TraversableOps[Int] performed by method traversable2ops in scala.collection.parallel.
     Definition Classes
       TraversableOps

155. #### def toParCollection[U >: Int, That](cbf: () ⇒ Combiner[U, That]): That

     Attributes
       protected
     Definition Classes
       ParIterableLike

156. #### def toParMap[K, V, That](cbf: () ⇒ Combiner[(K, V), That])(implicit ev: <:<[Int, (K, V)]): That

     Attributes
       protected
     Definition Classes
       ParIterableLike

157. #### def toSeq: ParSeq[Int]

     Converts this immutable parallel range to a sequence.

     Converts this immutable parallel range to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

     Note: will not terminate for infinite-sized collections.

     returns

       a sequence containing all elements of this immutable parallel range.

     Definition Classes
       ParSeq → ParIterable → ParSeqLike → ParIterableLike → GenSeqLike → GenTraversableOnce

158. #### def toSet[U >: Int]: ParSet[U]

     Converts this immutable parallel range to a set.

     Converts this immutable parallel range to a set.

     Note: will not terminate for infinite-sized collections.

     returns

       a set containing all elements of this immutable parallel range.

     Definition Classes
       ParIterableLike → GenTraversableOnce

159. #### def toStream: Stream[Int]

     Converts this immutable parallel range to a stream.

     Converts this immutable parallel range to a stream.

     Note: will not terminate for infinite-sized collections.

     returns

       a stream containing all elements of this immutable parallel range.

     Definition Classes
       ParIterableLike → GenTraversableOnce

160. #### def toString(): String

     Creates a String representation of this object.

     Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

     returns

       a String representation of the object.

     Definition Classes
       ParSeq → ParSeqLike → ParIterableLike → AnyRef → Any

161. #### def toTraversable: GenTraversable[Int]

     Converts this immutable parallel range to an unspecified Traversable.

     Converts this immutable parallel range to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     Note: will not terminate for infinite-sized collections.

     returns

       a Traversable containing all elements of this immutable parallel range.

     Definition Classes
       ParIterableLike → GenTraversableOnce

162. #### def toVector: Vector[Int]

     Converts this immutable parallel range to a Vector.

     Converts this immutable parallel range to a Vector.

     Note: will not terminate for infinite-sized collections.

     returns

       a vector containing all elements of this immutable parallel range.

     Definition Classes
       ParIterableLike → GenTraversableOnce

163. #### def transpose[B](implicit asTraversable: (Int) ⇒ GenTraversableOnce[B]): ParSeq[ParSeq[B]]

     Transposes this immutable parallel range of traversable collections into a immutable parallel range of immutable parallel ranges.

     Transposes this immutable parallel range of traversable collections into a immutable parallel range of immutable parallel ranges.

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this immutable parallel range is a `Traversable`.

     returns

       a two-dimensional immutable parallel range of immutable parallel ranges which has as nth row the nth column of this immutable parallel range.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown
       `IllegalArgumentException`

       if all collections in this immutable parallel range are not of the same size.

164. #### def union(that: GenSeq[Int]): ParRange[Int]

     [use case] Produces a new sequence which contains all elements of this immutable parallel range and also all elements of a given sequence.

     [use case]

     Produces a new sequence which contains all elements of this immutable parallel range and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Another way to express this is that `xs union ys` computes the order-presevring multi-set union of `xs` and `ys`. `union` is hence a counter-part of `diff` and `intersect` which also work on multi-sets.

     Note: will not terminate for infinite-sized collections.

     that

       the sequence to add.

     returns

       a new immutable parallel range which contains all elements of this immutable parallel range followed by all elements of `that`.

     Definition Classes
       GenSeqLike
     Full Signature

     #### def union[B >: Int, That](that: GenSeq[B])(implicit bf: CanBuildFrom[ParSeq[Int], B, That]): That

165. #### def unzip[A1, A2](implicit asPair: (Int) ⇒ (A1, A2)): (ParSeq[A1], ParSeq[A2])

     Converts this immutable parallel range of pairs into two collections of the first and second half of each pair.

     Converts this immutable parallel range of pairs into two collections of the first and second half of each pair.

     A1

       the type of the first half of the element pairs

     A2

       the type of the second half of the element pairs

     asPair

       an implicit conversion which asserts that the element type of this immutable parallel range is a pair.

     returns

       a pair immutable parallel ranges, containing the first, respectively second half of each element pair of this immutable parallel range.

     Definition Classes
       GenericTraversableTemplate

166. #### def unzip3[A1, A2, A3](implicit asTriple: (Int) ⇒ (A1, A2, A3)): (ParSeq[A1], ParSeq[A2], ParSeq[A3])

     Converts this immutable parallel range of triples into three collections of the first, second, and third element of each triple.

     Converts this immutable parallel range of triples into three collections of the first, second, and third element of each triple.

     A1

       the type of the first member of the element triples

     A2

       the type of the second member of the element triples

     A3

       the type of the third member of the element triples

     asTriple

       an implicit conversion which asserts that the element type of this immutable parallel range is a triple.

     returns

       a triple immutable parallel ranges, containing the first, second, respectively third member of each element triple of this immutable parallel range.

     Definition Classes
       GenericTraversableTemplate

167. #### def updated(index: Int, elem: A): ParRange[A]

     [use case] A copy of this immutable parallel range with one single replaced element.

     [use case]

     A copy of this immutable parallel range with one single replaced element.

     index

       the position of the replacement

     elem

       the replacing element

     returns

       a copy of this immutable parallel range with the element at position `index` replaced by `elem`.

     Definition Classes
       ParSeqLike → GenSeqLike
     Full Signature

     #### def updated[U >: Int, That](index: Int, elem: U)(implicit bf: CanBuildFrom[ParSeq[Int], U, That]): That

168. #### def view: ParSeqView[Int, ParSeq[Int], immutable.Seq[Int]]

     Definition Classes
       ParSeqLike → ParIterableLike

169. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws ( ... )

170. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws ( ... )

171. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws ( ... )

172. #### def wrap[R](body: ⇒ R): NonDivisible[R]

     Attributes
       protected
     Definition Classes
       ParIterableLike

173. #### def zip[B](that: GenIterable[B]): ParRange[(A, B)]

     [use case] Returns a immutable parallel range formed from this immutable parallel range and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a immutable parallel range formed from this immutable parallel range and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new immutable parallel range containing pairs consisting of corresponding elements of this immutable parallel range and `that`. The length of the returned collection is the minimum of the lengths of this immutable parallel range and `that`.

     Definition Classes
       ParSeqLike → ParIterableLike → GenIterableLike
     Full Signature

     #### def zip[U >: Int, S, That](that: GenIterable[S])(implicit bf: CanBuildFrom[ParSeq[Int], (U, S), That]): That

174. #### def zipAll[B](that: Iterable[B], thisElem: A, thatElem: B): ParRange[(A, B)]

     [use case] Returns a immutable parallel range formed from this immutable parallel range and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a immutable parallel range formed from this immutable parallel range and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this immutable parallel range is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this immutable parallel range.

     returns

       a new immutable parallel range containing pairs consisting of corresponding elements of this immutable parallel range and `that`. The length of the returned collection is the maximum of the lengths of this immutable parallel range and `that`. If this immutable parallel range is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this immutable parallel range, `thatElem` values are used to pad the result.

     Definition Classes
       ParIterableLike → GenIterableLike
     Full Signature

     #### def zipAll[S, U >: Int, That](that: GenIterable[S], thisElem: U, thatElem: S)(implicit bf: CanBuildFrom[ParSeq[Int], (U, S), That]): That

175. #### def zipWithIndex: ParRange[(A, Int)]

     [use case] Zips this immutable parallel range with its indices.

     [use case]

     Zips this immutable parallel range with its indices.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       A new immutable parallel range containing pairs consisting of all elements of this immutable parallel range paired with their index. Indices start at `0`.

     Definition Classes
       ParIterableLike → GenIterableLike
     Full Signature

     #### def zipWithIndex[U >: Int, That](implicit bf: CanBuildFrom[ParSeq[Int], (U, Int), That]): That

     Example:

     1. `List("a", "b", "c").zipWithIndex = List(("a", 0), ("b", 1), ("c", 2))`

176. #### def →[B](y: B): (ParRange, B)

     Implicit information
       This member is added by an implicit conversion from ParRange to ArrowAssoc[ParRange] performed by method any2ArrowAssoc in scala.Predef.
     Definition Classes
       ArrowAssoc

### Shadowed Implicit Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from ParRange to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (parRange: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from ParRange to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (parRange: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def /:\[A1 >: Int](z: A1)(op: (A1, A1) ⇒ A1): A1

   A syntactic sugar for out of order folding.

   A syntactic sugar for out of order folding. See `fold`.

   Example:

       scala> val a = LinkedList(1,2,3,4)
       a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

       scala> val b = (a /:\ 5)(_+_)
       b: Int = 15

   Definition Classes
     GenTraversableOnce
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) use fold instead

2. #### def x: ParRange

   Implicit information
     This member is added by an implicit conversion from ParRange to ArrowAssoc[ParRange] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (parRange: ArrowAssoc[ParRange]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

3. #### def x: ParRange

   Implicit information
     This member is added by an implicit conversion from ParRange to Ensuring[ParRange] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (parRange: Ensuring[ParRange]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from ParSeq[Int]

### Inherited from ParIterable[Int]

### Inherited from Immutable

### Inherited from parallel.ParSeq[Int]

### Inherited from ParSeqLike[Int, ParSeq[Int], immutable.Seq[Int]]

### Inherited from parallel.ParIterable[Int]

### Inherited from ParIterableLike[Int, ParSeq[Int], immutable.Seq[Int]]

### Inherited from Parallel

### Inherited from CustomParallelizable[Int, ParSeq[Int]]

### Inherited from GenericParTemplate[Int, ParSeq]

### Inherited from HasNewCombiner[Int, scala.collection.parallel.immutable.ParSeq[Int] @scala.annotation.unchecked.uncheckedVariance]

### Inherited from GenSeq[Int]

### Inherited from GenIterable[Int]

### Inherited from GenTraversable[Int]

### Inherited from GenericTraversableTemplate[Int, ParSeq]

### Inherited from HasNewBuilder[Int, scala.collection.parallel.immutable.ParSeq[Int] @scala.annotation.unchecked.uncheckedVariance]

### Inherited from GenSeqLike[Int, ParSeq[Int]]

### Inherited from Equals

### Inherited from GenIterableLike[Int, ParSeq[Int]]

### Inherited from GenTraversableLike[Int, ParSeq[Int]]

### Inherited from Parallelizable[Int, ParSeq[Int]]

### Inherited from GenTraversableOnce[Int]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion traversable2ops from ParRange to TraversableOps[Int]

### Inherited by implicit conversion any2stringadd from ParRange to StringAdd

### Inherited by implicit conversion any2stringfmt from ParRange to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from ParRange to ArrowAssoc[ParRange]

### Inherited by implicit conversion any2Ensuring from ParRange to Ensuring[ParRange]

### Ungrouped